TITLE Freehafer's disk file program
;.......................................................................
;					; message output macro
;.......................................................................
msg	MACRO	msgout
	mov AH, 09h			; function 09h
	lea DX, msgout		; DX holds message
	int 21h 			; display string interupt
ENDM
;.......................................................................
.MODEL small		      ; directive placing all memory in one segment
;.......................................................................
;
;.............................; stack segment...........................
StackSeg segment stack	      ; stack segment begins
StackSeg ends		      ; stack segment ends
;.......................................................................
;
;.............................; data segment............................
DataSeg segment
	Message 	DB 0Ah,0Dh,"     This program can make a file of floppy disk a:,",0Ah,0Dh,"     and put the data in c:\temp\diskfile!",0Ah,0Dh,0Ah,0Dh,"     You can read deleted files or data from a formatted",0Ah,0Dh,"     disk, if you open c:\temp\diskfile in something like Wordpad!", 0Ah,0Dh,0Ah,0Dh,"     This is true if the files are not overwritten!",0Ah,0Dh,'$'                  
	Inmsg		DB 0Ah,0Dh,"     Hit the R or r keys for a 1.457664 mb disk.",0Ah,0Dh,"     Hit the D or d keys for a 1.661440 mb disk.",0Ah,0Dh,"     Hit the P or p keys for a 1.720320 mb disk.",0Ah,0Dh,"     Hit the B or b keys for a 1.745408 mb disk.",0Ah,0Dh,"     These keys enable you to make a file of a particular floppy disk!",0Ah,0Dh,0Ah,0Dh,"     If you hit the E or e keys, the program will exit!",0Ah,0Dh,0Ah,0Dh
			DB "     If you hit the X or x keys you can slowly retrieve",0Ah,0Dh,"     the disk file to a floppy disk of the same format!",0Ah,0Dh,'$'
	Outmsg	DB 0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,"     Hit the R or r keys for a 1.457664 mb disk.",0Ah,0Dh,"     Hit the D or d keys for a 1.661440 mb disk.",0Ah,0Dh,"     Hit the P or p keys for a 1.720320 mb disk.",0Ah,0Dh,"     Hit the B or b keys for a 1.745408 mb disk.",0Ah,0Dh,"     These keys enable you to slowly retrieve the disk file!",0Ah,0Dh,0Ah,0Dh,"     If you hit the E or e keys, the program will exit!",0Ah,0Dh,0Ah,0Dh,'$'
	Rmsg		DB 0Ah,0Dh,"     You are using a 1.457664 mb disk of 2880 sectors.",0Ah,0Dh,'$'
	Dmsg		DB 0Ah,0Dh,"     You are using a 1.661440 mb disk of 3280 sectors.",0Ah,0Dh,'$'
	Pmsg		DB 0Ah,0Dh,"     You are using a 1.720320 mb disk of 3360 sectors.",0Ah,0Dh,'$'
	Bmsg		DB 0Ah,0Dh,"     You are using a 1.745408 mb disk of 3444 sectors.",0Ah,0Dh,'$'
	Emsg		DB 0Ah,0Dh,"     You chose to exit!",0Ah,0Dh,'$'
	Xmsg		DB 0Ah,0Dh,0Ah,0Dh,0Ah,0Dh,"     You chose to retrieve the disk file!",0Ah,0Dh,'$'
	Fmsg		DB 0Ah,0Dh,"     Freehafer's Disk File program is finished!",0Ah,0Dh,"     ",40h,"2002 Inniea Publishing Company!  R",153,142,"K NOG!",0Ah,0Dh,'$'
	Hmsg		DB 0Ah,0Dh,"     You are half done!",0Ah,0Dh,'$'
	dastmsg	DB 0Ah,0Dh,0Ah,0Dh,"     When writing to the 1.720320 mb disk, the first sector",0Ah,0Dh,"     is written last because the Windows 95 disk boot",0Ah,0Dh,"     sector is an unusual sector of a boot!",0Ah,0Dh,"     This program will not overwrite a Windows 95 disk!",0Ah,0Dh,"     It will write a Windows 95 disk to",0Ah,0Dh,"     a formatted disk of at least 3360 sectors!",0Ah,0Dh,0Ah,0Dh,'$'
	typdisk	DW 0					; type of disk 1, 2, 3, or 4
	counters	DW 0					; counter
	HANDLE	DW 0					; handle
	buffer 	DB 512 dup(?)			; buffer to receive data
	filename 	DB "c:\temp\diskfile",0 	; output file

DataSeg ends		      ; data segment ends	
;.......................................................................
;
;.............................; code segment begins.....................
CodeSeg segment  
;.......................................................................
;
;.............................; tell assembler which segment is in what register
assume cs:CodeSeg, ds:DataSeg, ss:StackSeg 
;.......................................................................
;              
start:     		            ; begin algorithm
;.......................................................................
;					; put data segment in ds
;.......................................................................
	mov AX, DataSeg		; base address
	mov DS, AX			; of data segment
;.......................................................................
;					; clear screen
;.......................................................................
	mov AH, 2			; function number
	mov BH, 0			; video page
	mov DX, 0			; top left corner
	int 10h			; interrupt call
;.......................................................................
;					; pink background with white font
;.......................................................................
	mov AH,9			; function number
	mov CX, 2000		; number of characters of output
	mov BL, 5Fh			; color code
	mov AL, " "			; blank characters
	int 10h			; call interrupt
;.......................................................................
	msg Message			; display output message
;.......................................................................
	msg Inmsg			; display input message
;.......................................................................
	mov AH, 01h			; read character function
	int 21h			; call interrupt
	.IF (AL == 82 || AL == 114)		; if 'R' or 'r' enterred......
	mov typdisk, 1				; 1.457664 Mb
	msg Rmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 68 || AL == 100)		; if 'D' or 'd' enterred .....
	mov typdisk, 2				; 1.661440 Mb
	msg Dmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 80 || AL == 112)		; if 'P' or 'p' enterred .....
	mov typdisk, 3				; 1.720320 Mb
	msg Pmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 66 || AL == 98)		; if 'B' or 'b' enterred......
	mov typdisk, 4				; 1.745408 Mb
	msg Bmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 69 || AL == 101) 		; if 'E' or 'e'enterred 
	msg Emsg					; exit message
	jmp err					; leave
	.ENDIF					; end if......................
	.IF (AL == 88 || AL == 120) 		; if 'X' or 'x'enterred 
	msg Xmsg					; retrive message
	jmp retrieve				; leave
	.ENDIF					; end if......................
;.......................................................................
					; create file
;.......................................................................
	mov AH, 3Ch			; create file function
	mov CX, 0			; file attribute is read only
;
	;mov DX, offset filename; DS:DX segment offset of file pathname
	lea DX, filename		; either line works
;
	int 21h			; interrupt call
	mov HANDLE, AX		; save handle
;.......................................................................
;					; read sectors
;.......................................................................
readloop:
	mov AL, 0			; drive a:
;
	;mov BX, offset buffer; DS:BX = segment:offset of buffer
	lea BX, buffer		; either line works
;
	mov CX, 1			; # of sectors to read
	mov DX, counters		; DOS beginning sector
	int 25h			; interrupt call
;.......................................................................
					; write sectors to file
;.......................................................................
	mov BX, HANDLE		; file handle
	mov AH, 40h			; write to file function
	mov CX, 512			; # of bytes to write
;
	;mov DX, offset buffer; DS:DX segment offset of buffer
	lea DX, buffer		; either line works
;
	int 21h			; interrupt call
;.......................................................................
	inc counters		;
;.......................................................................
;					; half way test
;.......................................................................
	.IF (counters == 1400) 	; half done
	msg Hmsg			; half done message
	.ENDIF
;.......................................................................
;					; end loop
;.......................................................................
	.IF(counters < 2880 && typdisk == 1)	
	jmp readloop		;
	.ENDIF	; 512		2880 		regular	1457664	80	18	2
	;.................................................................
	.IF(counters < 3280 && typdisk == 2)	
	jmp readloop		;
	.ENDIF	; 512		3280		MS DMF	1661440	82	20	2
	;.................................................................
	.IF(counters < 3360 && typdisk == 3)	
	jmp readloop		;
	.ENDIF	; 512		3360 		extra		1720320	80	21	2
	;.................................................................
	.IF(counters < 3444 && typdisk == 4)	
	jmp readloop		;
	.ENDIF	; 512		3444		BIG DMF	1745408	82	21	2
	;.................................................................
	;				
	; 		bps		sectors	disk		bytes		cyl	s/t	heads
	; 730.......; 1024	713		730		730112	80	9	2 
;.......................................................................
;					; retrieve disk file
;.......................................................................
	jmp err			; skip retrieve unless asked not to
retrieve:				; beginning of retrieve
;.......................................................................
	msg Outmsg			; display input message
;.......................................................................
	mov AH, 01h			; read character function
	int 21h			; call interrupt
	.IF (AL == 82 || AL == 114)		; if 'R' or 'r' enterred......
	mov typdisk, 1				; 1.457664 Mb
	msg Rmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 68 || AL == 100)		; if 'D' or 'd' enterred .....
	mov typdisk, 2				; 1.661440 Mb
	msg Dmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 80 || AL == 112)		; if 'P' or 'p' enterred .....
	mov typdisk, 3				; 1.720320 Mb
	msg Pmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 66 || AL == 98)		; if 'B' or 'b' enterred......
	mov typdisk, 4				; 1.745408 Mb
	msg Bmsg					; message
	.ENDIF					; end if......................
	.IF (AL == 69 || AL == 101) 		; if 'E' or 'e'enterred 
	msg Emsg					; exit message
	jmp err					; leave
	.ENDIF					; end if......................
;.......................................................................
	mov counters, 0		; reset counter
	.IF (typdisk == 3)	;
	msg dastmsg			; 
	mov counters, 1		; skip first sector in case DMF
	.ENDIF			; 
					; open disk file
;.......................................................................
;					; open disk file
;.......................................................................
	mov AH, 3Dh			; open file function
	mov AL, 2			; access mode read and write
	mov CX, 0			; file attribute is read only
;
	;mov DX, offset filename; DS:DX segment offset of file pathname
	lea DX, filename		; either line works
;
	int 21h			; interrupt call
	mov HANDLE, AX		; save handle
;.......................................................................
;					; set read file pointer
;.......................................................................
todisk:
	mov DX, 0			; empty DX
	mov CX, 0			; empty CX
	mov AX, 512			; AX = 512
	mul counters		; AX,DX = AX * counters = 512 * counters
	mov CX, DX			; CX has low part of 32 bit value of file pointer
	mov DX, AX			; DX has high part of 32 bit value of file pointer
;.......................................................................
	mov BX, HANDLE		; file handle
	mov AL, 0h			; pointer is offset from begining location
	mov AH, 42h			; set pointer function
	int 21h			; interrupt call
;.......................................................................
;					; read file sector by sector
;.......................................................................
	mov BX, HANDLE		; file handle
	mov AH, 3Fh			; read file function
	mov CX, 512			; # of bytes to read
;
	;mov DX, offset buffer; DS:DX segment offset of buffer
	lea DX, buffer		; either line works
;
	int 21h			; interrupt call
;.......................................................................
					; write it to sector
;.......................................................................
	mov AL, 0			; drive a:
;
	;mov BX, offset buffer; DS:BX = segment:offset of buffer
	lea BX, buffer		; either line works
;
	mov CX, 1			; # of sectors to write
	mov DX, counters		; sector number
	int 26h			; write interrupt call
;.......................................................................
	inc counters		;
;.......................................................................
;					; half way test
;.......................................................................
	.IF (counters == 1400) 	; half done
	msg Hmsg			; half done message
	.ENDIF
;.......................................................................
;					; end loop
;.......................................................................
	.IF(counters < 2880 && typdisk == 1)	
	jmp todisk			;
	.ENDIF	; 512		2880 		regular	1457664	80	18	2
	;.................................................................
	.IF(counters < 3280 && typdisk == 2)	
	jmp todisk		;
	.ENDIF	; 512		3280		MS DMF	1661440	82	20	2
	;.................................................................
	.IF(counters < 3360 && typdisk == 3)	
	jmp todisk		;
	.ENDIF	; 512		3360		extra		1720320	80	21	2
	;.................................................................
	.IF(counters < 3444 && typdisk == 4)	
	jmp todisk		;
	.ENDIF	; 512		3444		BIG DMF	1745408	82	21	2
	;.................................................................				
	; 		bps		sectors	disk		bytes		cyl	s/t	heads
	; 730.......; 1024	713		730		730112	80	9	2 
;.......................................................................
;					; copy boot sector last if DMF
;.......................................................................
	.IF (typdisk == 3)
	; get pointer.....................................................
	mov DX, 0			; empty DX
	mov CX, 0			; empty CX
	mov BX, HANDLE		; file handle
	mov AL, 0h			; pointer is offset from begining location
	mov AH, 42h			; set pointer function
	int 21h			; interrupt call
	; read 512 bytes of beginning of file.............................
	mov BX, HANDLE		; file handle
	mov AH, 3Fh			; read file function
	mov CX, 512			; # of bytes to read
	lea DX, buffer		; either line works
	int 21h			; interrupt call
	; write boot sector...............................................
	mov AL, 0			; drive a:
	lea BX, buffer		; either line works
	mov CX, 1			; # of sectors to write
	mov DX, 0			; boot sector number
	int 26h			; write interrupt call
	.ENDIF
;.......................................................................
err:					; terminate program
;.......................................................................
;					; close file
;.......................................................................
	mov BX, HANDLE		; handle of disk file
	mov ah, 3eh			; close file
	int 21h			; interrupt call
;.......................................................................
	msg Fmsg			; termination message
;.......................................................................
	mov AX,4C00h		; termination function
	int 21h			; termination interupt
CodeSeg    ends       	      ; end algorithm
;.......................................................................
end  start 			      ; end program


